Index: src/joiner.cpp
===================================================================
--- src/joiner.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/joiner.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -47,13 +47,13 @@
   bool NoHessian = false;
 
-  Log() << Verbose(0) << "Joiner" << endl;
-  Log() << Verbose(0) << "======" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Joiner" << endl);
+  DoLog(0) && (Log() << Verbose(0) << "======" << endl);
 
   // Get the command line options
   if (argc < 3) {
-    Log() << Verbose(0) << "Usage: " << argv[0] << " <inputdir> <prefix> [elementsdb]" << endl;
-    Log() << Verbose(0) << "<inputdir>\ttherein the output of a molecuilder fragmentation is expected, each fragment with a subdir containing an energy.all and a forces.all file." << endl;
-    Log() << Verbose(0) << "<prefix>\tprefix of energy and forces file." << endl;
-    Log() << Verbose(0) << "[elementsdb]\tpath to elements database, needed for shieldings." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Usage: " << argv[0] << " <inputdir> <prefix> [elementsdb]" << endl);
+    DoLog(0) && (Log() << Verbose(0) << "<inputdir>\ttherein the output of a molecuilder fragmentation is expected, each fragment with a subdir containing an energy.all and a forces.all file." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "<prefix>\tprefix of energy and forces file." << endl);
+    DoLog(0) && (Log() << Verbose(0) << "[elementsdb]\tpath to elements database, needed for shieldings." << endl);
     return 1;
   } else {
@@ -77,10 +77,10 @@
   if (!Hcorrection.ParseFragmentMatrix(argv[1], "", HCORRECTIONSUFFIX, 0,0)) {
     NoHCorrection = true;
-    Log() << Verbose(0) << "No HCorrection matrices found, skipping these." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "No HCorrection matrices found, skipping these." << endl);
   }
   if (!Force.ParseFragmentMatrix(argv[1], dir, ForcesSuffix, 0,0)) return 1;
   if (!Hessian.ParseFragmentMatrix(argv[1], dir, HessianSuffix, 0,0)) {
     NoHessian = true;
-    Log() << Verbose(0) << "No hessian matrices found, skipping these." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "No hessian matrices found, skipping these." << endl);
   }
   if (periode != NULL) { // also look for PAS values
@@ -146,5 +146,5 @@
   for (int BondOrder=0;BondOrder<KeySet.Order;BondOrder++) {
     // --------- sum up energy --------------------
-    Log() << Verbose(0) << "Summing energy of order " << BondOrder+1 << " ..." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Summing energy of order " << BondOrder+1 << " ..." << endl);
     if (!EnergyFragments.SumSubManyBodyTerms(Energy, KeySet, BondOrder)) return 1;
     if (!NoHCorrection) { 
@@ -155,15 +155,15 @@
       if (!Energy.SumSubEnergy(EnergyFragments, NULL, KeySet, BondOrder, 1.)) return 1;
     // --------- sum up Forces --------------------
-    Log() << Verbose(0) << "Summing forces of order " << BondOrder+1 << " ..." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Summing forces of order " << BondOrder+1 << " ..." << endl);
     if (!ForceFragments.SumSubManyBodyTerms(Force, KeySet, BondOrder)) return 1;
     if (!Force.SumSubForces(ForceFragments, KeySet, BondOrder, 1.)) return 1;
     // --------- sum up Hessian --------------------
     if (!NoHessian) {
-      Log() << Verbose(0) << "Summing Hessian of order " << BondOrder+1 << " ..." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Summing Hessian of order " << BondOrder+1 << " ..." << endl);
       if (!HessianFragments.SumSubManyBodyTerms(Hessian, KeySet, BondOrder)) return 1;
       if (!Hessian.SumSubHessians(HessianFragments, KeySet, BondOrder, 1.)) return 1;
     }
     if (periode != NULL) { // also look for PAS values
-      Log() << Verbose(0) << "Summing shieldings and susceptibilities of order " << BondOrder+1 << " ..." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Summing shieldings and susceptibilities of order " << BondOrder+1 << " ..." << endl);
       if (!ShieldingFragments.SumSubManyBodyTerms(Shielding, KeySet, BondOrder)) return 1;
       if (!Shielding.SumSubForces(ShieldingFragments, KeySet, BondOrder, 1.)) return 1;
@@ -179,5 +179,5 @@
     prefix.str(" ");
     prefix << dir << OrderSuffix << (BondOrder+1);
-    Log() << Verbose(0) << "Writing files " << argv[1] << prefix.str() << ". ..." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Writing files " << argv[1] << prefix.str() << ". ..." << endl);
     // energy
     if (!Energy.WriteLastMatrix(argv[1], (prefix.str()).c_str(), EnergySuffix)) return 1;
@@ -244,5 +244,5 @@
   delete(periode);
   Free(&dir);
-  Log() << Verbose(0) << "done." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done." << endl);
   return 0;
 };
Index: src/leastsquaremin.cpp
===================================================================
--- src/leastsquaremin.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/leastsquaremin.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -25,5 +25,5 @@
   for (int i=num;i--;) {
     for(int j=NDIM;j--;)
-      sum += (gsl_vector_get(x,j) - (vectors[i])->x[j])*(gsl_vector_get(x,j) - (vectors[i])->x[j]);
+      sum += (gsl_vector_get(x,j) - (vectors[i])->at(j))*(gsl_vector_get(x,j) - (vectors[i])->at(j));
   }
 
Index: src/leastsquaremin.hpp
===================================================================
--- src/leastsquaremin.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/leastsquaremin.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -42,5 +42,5 @@
   gsl_vector *x;
   const molecule *mol;
-  element *type;
+  const element *type;
 };
 
Index: src/linearsystemofequations.cpp
===================================================================
--- src/linearsystemofequations.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/linearsystemofequations.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -54,5 +54,5 @@
 {
   assert ( columns == NDIM && "Vector class is always three-dimensional, unlike this LEqS!");
-  b->SetFromDoubleArray(x->x);
+  b->SetFromDoubleArray(x->get());
 };
 
@@ -100,5 +100,5 @@
   // copy solution
   for (size_t i=0;i<x->dimension;i++)
-    v.x[i] = x->Get(i);
+    v[i] = x->Get(i);
   return status;
 };
Index: src/linkedcell.cpp
===================================================================
--- src/linkedcell.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/linkedcell.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -45,7 +45,7 @@
   max.Zero();
   min.Zero();
-  Log() << Verbose(1) << "Begin of LinkedCell" << endl;
-  if (set->IsEmpty()) {
-    eLog() << Verbose(1) << "set contains no linked cell nodes!" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of LinkedCell" << endl);
+  if ((set == NULL) || (set->IsEmpty())) {
+    DoeLog(1) && (eLog()<< Verbose(1) << "set is NULL or contains no linked cell nodes!" << endl);
     return;
   }
@@ -54,6 +54,6 @@
   Walker = set->GetPoint();
   for (int i=0;i<NDIM;i++) {
-    max.x[i] = Walker->node->x[i];
-    min.x[i] = Walker->node->x[i];
+    max[i] = Walker->node->at(i);
+    min[i] = Walker->node->at(i);
   }
   set->GoToFirst();
@@ -61,23 +61,23 @@
     Walker = set->GetPoint();
     for (int i=0;i<NDIM;i++) {
-      if (max.x[i] < Walker->node->x[i])
-        max.x[i] = Walker->node->x[i];
-      if (min.x[i] > Walker->node->x[i])
-        min.x[i] = Walker->node->x[i];
+      if (max[i] < Walker->node->at(i))
+        max[i] = Walker->node->at(i);
+      if (min[i] > Walker->node->at(i))
+        min[i] = Walker->node->at(i);
     }
     set->GoToNext();
   }
-  Log() << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl);
 
   // 2. find then number of cells per axis
   for (int i=0;i<NDIM;i++) {
-    N[i] = (int)floor((max.x[i] - min.x[i])/RADIUS)+1;
-  }
-  Log() << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl;
+    N[i] = static_cast<int>(floor((max[i] - min[i])/RADIUS)+1);
+  }
+  DoLog(2) && (Log() << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl);
 
   // 3. allocate the lists
-  Log() << Verbose(2) << "Allocating cells ... ";
+  DoLog(2) && (Log() << Verbose(2) << "Allocating cells ... ");
   if (LC != NULL) {
-    eLog() << Verbose(1) << "Linked Cell list is already allocated, I do nothing." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell list is already allocated, I do nothing." << endl);
     return;
   }
@@ -86,13 +86,13 @@
     LC [index].clear();
   }
-  Log() << Verbose(0) << "done."  << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
 
   // 4. put each atom into its respective cell
-  Log() << Verbose(2) << "Filling cells ... ";
+  DoLog(2) && (Log() << Verbose(2) << "Filling cells ... ");
   set->GoToFirst();
   while (!set->IsEnd()) {
     Walker = set->GetPoint();
     for (int i=0;i<NDIM;i++) {
-      n[i] = (int)floor((Walker->node->x[i] - min.x[i])/RADIUS);
+      n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
     }
     index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
@@ -101,6 +101,6 @@
     set->GoToNext();
   }
-  Log() << Verbose(0) << "done."  << endl;
-  Log() << Verbose(1) << "End of LinkedCell" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
+  DoLog(1) && (Log() << Verbose(1) << "End of LinkedCell" << endl);
 };
 
@@ -120,7 +120,7 @@
   max.Zero();
   min.Zero();
-  Log() << Verbose(1) << "Begin of LinkedCell" << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Begin of LinkedCell" << endl);
   if (set->empty()) {
-    eLog() << Verbose(1) << "set contains no linked cell nodes!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "set contains no linked cell nodes!" << endl);
     return;
   }
@@ -128,28 +128,28 @@
   LinkedNodes::iterator Runner = set->begin();
   for (int i=0;i<NDIM;i++) {
-    max.x[i] = (*Runner)->node->x[i];
-    min.x[i] = (*Runner)->node->x[i];
+    max[i] = (*Runner)->node->at(i);
+    min[i] = (*Runner)->node->at(i);
   }
   for (LinkedNodes::iterator Runner = set->begin(); Runner != set->end(); Runner++) {
     Walker = *Runner;
     for (int i=0;i<NDIM;i++) {
-      if (max.x[i] < Walker->node->x[i])
-        max.x[i] = Walker->node->x[i];
-      if (min.x[i] > Walker->node->x[i])
-        min.x[i] = Walker->node->x[i];
+      if (max[i] < Walker->node->at(i))
+        max[i] = Walker->node->at(i);
+      if (min[i] > Walker->node->at(i))
+        min[i] = Walker->node->at(i);
     }
   }
-  Log() << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl);
 
   // 2. find then number of cells per axis
   for (int i=0;i<NDIM;i++) {
-    N[i] = (int)floor((max.x[i] - min.x[i])/RADIUS)+1;
-  }
-  Log() << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl;
+    N[i] = static_cast<int>(floor((max[i] - min[i])/RADIUS)+1);
+  }
+  DoLog(2) && (Log() << Verbose(2) << "Number of cells per axis are " << N[0] << ", " << N[1] << " and " << N[2] << "." << endl);
 
   // 3. allocate the lists
-  Log() << Verbose(2) << "Allocating cells ... ";
+  DoLog(2) && (Log() << Verbose(2) << "Allocating cells ... ");
   if (LC != NULL) {
-    eLog() << Verbose(1) << "Linked Cell list is already allocated, I do nothing." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell list is already allocated, I do nothing." << endl);
     return;
   }
@@ -158,12 +158,12 @@
     LC [index].clear();
   }
-  Log() << Verbose(0) << "done."  << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
 
   // 4. put each atom into its respective cell
-  Log() << Verbose(2) << "Filling cells ... ";
+  DoLog(2) && (Log() << Verbose(2) << "Filling cells ... ");
   for (LinkedNodes::iterator Runner = set->begin(); Runner != set->end(); Runner++) {
     Walker = *Runner;
     for (int i=0;i<NDIM;i++) {
-      n[i] = (int)floor((Walker->node->x[i] - min.x[i])/RADIUS);
+      n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
     }
     index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
@@ -171,6 +171,6 @@
     //Log() << Verbose(2) << *Walker << " goes into cell " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
   }
-  Log() << Verbose(0) << "done."  << endl;
-  Log() << Verbose(1) << "End of LinkedCell" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "done."  << endl);
+  DoLog(1) && (Log() << Verbose(1) << "End of LinkedCell" << endl);
 };
 
@@ -199,5 +199,5 @@
     status = status && ((n[i] >=0) && (n[i] < N[i]));
   if (!status)
-  eLog() << Verbose(1) << "indices are out of bounds!" << endl;
+  DoeLog(1) && (eLog()<< Verbose(1) << "indices are out of bounds!" << endl);
   return status;
 };
@@ -220,5 +220,5 @@
  * \return LinkedAtoms pointer to current cell, NULL if LinkedCell::n[] are out of bounds.
  */
-const LinkedNodes* LinkedCell::GetCurrentCell() const
+const LinkedCell::LinkedNodes* LinkedCell::GetCurrentCell() const
 {
   if (CheckBounds()) {
@@ -234,5 +234,5 @@
  * \return LinkedAtoms pointer to current cell, NULL if LinkedCell::n[]+relative[] are out of bounds.
  */
-const LinkedNodes* LinkedCell::GetRelativeToCurrentCell(const int relative[NDIM]) const
+const LinkedCell::LinkedNodes* LinkedCell::GetRelativeToCurrentCell(const int relative[NDIM]) const
 {
   if (CheckBounds(relative)) {
@@ -244,4 +244,16 @@
 };
 
+/** Set the index to the cell containing a given Vector *x.
+ * \param *x Vector with coordinates
+ * \return Vector is inside bounding box - true, else - false
+ */
+bool LinkedCell::SetIndexToVector(const Vector * const x) const
+{
+  for (int i=0;i<NDIM;i++)
+    n[i] = (int)floor((x->at(i) - min[i])/RADIUS);
+
+  return CheckBounds();
+};
+
 /** Calculates the index for a given LCNode *Walker.
  * \param *Walker LCNode to set index tos
@@ -252,5 +264,5 @@
   bool status = false;
   for (int i=0;i<NDIM;i++) {
-    n[i] = (int)floor((Walker->node->x[i] - min.x[i])/RADIUS);
+    n[i] = static_cast<int>(floor((Walker->node->at(i) - min[i])/RADIUS));
   }
   index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
@@ -260,5 +272,5 @@
     return status;
   } else {
-    eLog() << Verbose(1) << "Node at " << *Walker << " is out of bounds." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Node at " << *Walker << " is out of bounds." << endl);
     return false;
   }
@@ -268,36 +280,137 @@
  * \param *lower lower bounds
  * \param *upper upper bounds
- */
-void LinkedCell::GetNeighbourBounds(int lower[NDIM], int upper[NDIM]) const
-{
-  for (int i=0;i<NDIM;i++) {
-    lower[i] = ((n[i]-1) >= 0) ? n[i]-1 : 0;
-    upper[i] = ((n[i]+1) < N[i]) ? n[i]+1 : N[i]-1;
-    //Log() << Verbose(0) << " [" << Nlower[i] << "," << Nupper[i] << "] ";
-    // check for this axis whether the point is outside of our grid
+ * \param step how deep to check the neighbouring cells (i.e. number of layers to check)
+ */
+void LinkedCell::GetNeighbourBounds(int lower[NDIM], int upper[NDIM], int step) const
+{
+  for (int i=0;i<NDIM;i++) {
+    lower[i] = n[i];
+    for (int s=step; s>0;--s)
+      if ((n[i]-s) >= 0) {
+        lower[i] = n[i]-s;
+        break;
+      }
+    upper[i] = n[i];
+    for (int s=step; s>0;--s)
+      if ((n[i]+s) < N[i]) {
+        upper[i] = n[i]+s;
+        break;
+      }
+    //Log() << Verbose(0) << "axis " << i << " has bounds [" << lower[i] << "," << upper[i] << "]" << endl;
+  }
+};
+
+/** Returns a list with all neighbours from the current LinkedCell::index.
+ * \param distance (if no distance, then adjacent cells are taken)
+ * \return list of tesselpoints
+ */
+LinkedCell::LinkedNodes* LinkedCell::GetallNeighbours(const double distance) const
+{
+  int Nlower[NDIM], Nupper[NDIM];
+  TesselPoint *Walker = NULL;
+  LinkedNodes *TesselList = new LinkedNodes;
+
+  // then go through the current and all neighbouring cells and check the contained points for possible candidates
+  const int step = (distance == 0) ? 1 : (int)floor(distance/RADIUS + 1.);
+  GetNeighbourBounds(Nlower, Nupper, step);
+
+  //Log() << Verbose(0) << endl;
+  for (n[0] = Nlower[0]; n[0] <= Nupper[0]; n[0]++)
+    for (n[1] = Nlower[1]; n[1] <= Nupper[1]; n[1]++)
+      for (n[2] = Nlower[2]; n[2] <= Nupper[2]; n[2]++) {
+        const LinkedNodes *List = GetCurrentCell();
+        //Log() << Verbose(1) << "Current cell is " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
+        if (List != NULL) {
+          for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+            Walker = *Runner;
+            TesselList->push_back(Walker);
+          }
+        }
+      }
+  return TesselList;
+};
+
+/** Set the index to the cell containing a given Vector *x, which is not inside the LinkedCell's domain
+ * Note that as we have to check distance from every corner of the closest cell, this function is faw more
+ * expensive and if Vector is known to be inside LinkedCell's domain, then SetIndexToVector() should be used.
+ * \param *x Vector with coordinates
+ * \return minimum squared distance of cell to given vector (if inside of domain, distance is 0)
+ */
+double LinkedCell::SetClosestIndexToOutsideVector(const Vector * const x) const
+{
+  for (int i=0;i<NDIM;i++) {
+    n[i] = (int)floor((x->at(i) - min[i])/RADIUS);
     if (n[i] < 0)
-      upper[i] = lower[i];
-    if (n[i] > N[i])
-      lower[i] = upper[i];
-
-    //Log() << Verbose(0) << "axis " << i << " has bounds [" << lower[i] << "," << upper[i] << "]" << endl;
-  }
-};
-
-/** Calculates the index for a given Vector *x.
- * \param *x Vector with coordinates
- * \return Vector is inside bounding box - true, else - false
- */
-bool LinkedCell::SetIndexToVector(const Vector * const x) const
-{
-  bool status = true;
-  for (int i=0;i<NDIM;i++) {
-    n[i] = (int)floor((x->x[i] - min.x[i])/RADIUS);
-    if (max.x[i] < x->x[i])
-      status = false;
-    if (min.x[i] > x->x[i])
-      status = false;
-  }
-  return status;
-};
-
+      n[i] = 0;
+    if (n[i] >= N[i])
+      n[i] = N[i]-1;
+  }
+
+  // calculate distance of cell to vector
+  double distanceSquared = 0.;
+  bool outside = true;  // flag whether x is found in- or outside of LinkedCell's domain/closest cell
+  Vector corner; // current corner of closest cell
+  Vector tester; // Vector pointing from corner to center of closest cell
+  Vector Distance;  // Vector from corner of closest cell to x
+
+  Vector center;  // center of the closest cell
+  for (int i=0;i<NDIM;i++)
+    center[i] = min[i]+((double)n[i]+.5)*RADIUS;
+
+  int c[NDIM];
+  for (c[0]=0;c[0]<=1;c[0]++)
+    for (c[1]=0; c[1]<=1;c[1]++)
+      for (c[2]=0; c[2]<=1;c[2]++) {
+        // set up corner
+        for (int i=0;i<NDIM;i++)
+          corner[i] = min[i]+RADIUS*((double)n[i]+c[i]);
+        // set up distance vector
+        Distance = (*x) - corner;
+        const double dist = Distance.NormSquared();
+        // check whether distance is smaller
+        if (dist< distanceSquared)
+          distanceSquared = dist;
+        // check whether distance vector goes inside or outside
+        tester = center -corner;
+        if (tester.ScalarProduct(Distance) < 0)
+          outside = false;
+      }
+  return (outside ? distanceSquared : 0.);
+};
+
+/** Returns a list of all TesselPoint with distance less than \a radius to \a *Center.
+ * \param radius radius of sphere
+ * \param *center center of sphere
+ * \return list of all points inside sphere
+ */
+LinkedCell::LinkedNodes* LinkedCell::GetPointsInsideSphere(const double radius, const Vector * const center) const
+{
+  const double radiusSquared = radius*radius;
+  TesselPoint *Walker = NULL;
+  LinkedNodes *TesselList = new LinkedNodes;
+  LinkedNodes *NeighbourList = NULL;
+
+  // set index of LC to center of sphere
+  const double dist = SetClosestIndexToOutsideVector(center);
+  if (dist > 2.*radius) {
+    DoeLog(1) && (eLog()<< Verbose(1) << "Vector " << *center << " is too far away from any atom in LinkedCell's bounding box." << endl);
+    return TesselList;
+  } else
+    DoLog(1) && (Log() << Verbose(1) << "Distance of closest cell to center of sphere with radius " << radius << " is " << dist << "." << endl);
+
+  // gather all neighbours first, then look who fulfills distance criteria
+  NeighbourList = GetallNeighbours(2.*radius-dist);
+  //Log() << Verbose(1) << "I found " << NeighbourList->size() << " neighbours to check." << endl;
+  if (NeighbourList != NULL) {
+    for (LinkedNodes::const_iterator Runner = NeighbourList->begin(); Runner != NeighbourList->end(); Runner++) {
+      Walker = *Runner;
+      //Log() << Verbose(1) << "Current neighbour is at " << *Walker->node << "." << endl;
+      if ((center->DistanceSquared(*Walker->node) - radiusSquared) < MYEPSILON) {
+        TesselList->push_back(Walker);
+      }
+    }
+    delete(NeighbourList);
+  } else
+    DoeLog(2) && (eLog()<< Verbose(2) << "Around vector " << *center << " there are no atoms." << endl);
+  return TesselList;
+};
Index: src/linkedcell.hpp
===================================================================
--- src/linkedcell.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/linkedcell.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -33,5 +33,4 @@
 /********************************************** definitions *********************************/
 
-#define LinkedNodes list<TesselPoint *>
 
 /********************************************** declarations *******************************/
@@ -40,5 +39,10 @@
  */
 class LinkedCell {
-  public:
+private:
+
+public:
+  typedef list<TesselPoint *> LinkedNodes;
+
+
     Vector max;       // upper boundary
     Vector min;       // lower boundary
@@ -53,12 +57,15 @@
     LinkedCell(LinkedNodes *set, const double radius);
     ~LinkedCell();
-    const LinkedNodes* GetCurrentCell()const ;
-    const LinkedNodes* GetRelativeToCurrentCell(const int relative[NDIM])const ;
+    const LinkedCell::LinkedNodes* GetCurrentCell()const ;
+    const LinkedCell::LinkedNodes* GetRelativeToCurrentCell(const int relative[NDIM])const ;
     bool SetIndexToNode(const TesselPoint * const Walker)const ;
     bool SetIndexToVector(const Vector * const x)const ;
+    double SetClosestIndexToOutsideVector(const Vector * const x) const;
     bool CheckBounds()const ;
     bool CheckBounds(const int relative[NDIM])const ;
-    void GetNeighbourBounds(int lower[NDIM], int upper[NDIM])const ;
+    void GetNeighbourBounds(int lower[NDIM], int upper[NDIM], int step = 1)const ;
 
+    LinkedCell::LinkedNodes* GetallNeighbours(const double distance = 0) const;
+    LinkedCell::LinkedNodes* GetPointsInsideSphere(const double radius, const Vector * const center) const;
     // not implemented yet
     bool AddNode(Vector *Walker);
Index: src/lists.cpp
===================================================================
--- src/lists.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/lists.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,21 @@
+/*
+ * lists.cpp
+ *
+ *  Created on: Feb 24, 2010
+ *      Author: crueger
+ */
+
+#include "lists.hpp"
+#include "World.hpp"
+#include "atom.hpp"
+
+// specialized templates for lists
+// can be directly compiled since no further templatization is needed
+template <> void removewithoutcheck<atom>(atom *walker)
+{
+  if (walker != 0) {
+    unlink(walker);
+    walker->getWorld()->destroyAtom(walker);
+    walker = 0;
+  }
+};
Index: src/lists.hpp
===================================================================
--- src/lists.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/lists.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,4 +9,6 @@
 #define LISTS_HPP_
 
+class atom;
+
 /******************************** Some templates for list management ***********************************/
 
@@ -18,5 +20,5 @@
 {
   X *vorher = end->previous;
-  if (vorher != NULL)
+  if (vorher != 0)
     vorher->next = walker;
   end->previous = walker;
@@ -31,10 +33,10 @@
 template <typename X> void unlink(X *walker)
 {
-  if (walker->next != NULL)
+  if (walker->next != 0)
     walker->next->previous = walker->previous;
-  if (walker->previous != NULL)
+  if (walker->previous != 0)
     walker->previous->next = walker->next;
-  walker->next = NULL;
-  walker->previous= NULL;
+  walker->next = 0;
+  walker->previous= 0;
 };
 
@@ -46,9 +48,9 @@
 template <typename X>  bool add(X *pointer, X *end)
 {
-  if (end != NULL) {
+  if (end != 0) {
     link(pointer, end);
   } else {
-    pointer->previous = NULL;
-    pointer->next = NULL;
+    pointer->previous = 0;
+    pointer->next = 0;
   }
   return true;
@@ -59,5 +61,5 @@
  * \param *start  begin of list
  * \param *end  end of list
- * \return X - if found, NULL - if not found
+ * \return X - if found, 0 - if not found
  */
 template <typename X, typename Y> X * find(Y *suche, X *start, X *end)
@@ -68,5 +70,5 @@
     if (*walker->sort == *suche) return (walker);
   }
-  return NULL;
+  return 0;
 };
 
@@ -77,10 +79,18 @@
 template <typename X> void removewithoutcheck(X *walker)
 {
-  if (walker != NULL) {
+  if (walker != 0) {
     unlink(walker);
     delete(walker);
-    walker = NULL;
+    walker = 0;
   }
 };
+
+/** Removes an item from the list without check.
+ *  specialized for atoms, because these have to be removed from the world as well
+ *  the implementation for this declaration is in lists.cpp
+ * \param *walker item to be removed
+ * \return true - removing succeeded, false - given item not found in list
+ */
+template <> void removewithoutcheck<atom>(atom *walker);
 
 /** Removes an item from the list, checks if exists.
@@ -99,5 +109,5 @@
   }*/
   // atom found, now unlink
-  if (walker != NULL)
+  if (walker != 0)
     removewithoutcheck(walker);
   else
@@ -114,5 +124,5 @@
 {
   X *pointer = start->next;
-  X *walker = NULL;
+  X *walker = 0;
   while (pointer != end) { // go through list
     walker = pointer; // mark current
@@ -131,5 +141,5 @@
 {
   X *Binder = me;
-  while(Binder->previous != NULL)
+  while(Binder->previous != 0)
     Binder = Binder->previous;
   return Binder;
@@ -143,5 +153,5 @@
 {
   X *Binder = me;
-  while(Binder->next != NULL)
+  while(Binder->next != 0)
     Binder = Binder->next;
   return Binder;
Index: src/log.cpp
===================================================================
--- src/log.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/log.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,6 +15,5 @@
  */
 void setVerbosity(int verbosityLevel) {
-  logger::getInstance()->setVerbosity(verbosityLevel);
-  errorLogger::getInstance()->setVerbosity(verbosityLevel);
+  logger::getInstance().setVerbosity(verbosityLevel);
 }
 
@@ -24,6 +23,28 @@
  * \param indentation level of the message to log
  */
-class logger * Log() {
+class logger& Log() {
   return logger::getInstance();
+}
+
+/** Checks verbosity for logger.
+ * Is supposed to be used in construct as this:
+ * DoLog(2) && (Log() << Verbose(2) << "message." << endl);
+ * If DoLog does not return true, the right-hand side is not evaluated and we save some time.
+ * \param verbose verbosity level of this message
+ * \return true - print, false - don't
+ */
+bool DoLog(int verbose) {
+  return (verbose <= logger::getInstance().verbosity);
+}
+
+/** Checks verbosity for errorlogger.
+ * Is supposed to be used in construct as this:
+ * DoLog(2) && (Log() << Verbose(2) << "message." << endl);
+ * If DoLog does not return true, the right-hand side is not evaluated and we save some time.
+ * \param verbose verbosity level of this message
+ * \return true - print, false - don't
+ */
+bool DoeLog(int verbose) {
+  return (verbose <= errorLogger::getInstance().verbosity);
 }
 
@@ -33,5 +54,5 @@
  * \param indentation level of the message to log
  */
-class errorLogger * eLog() {
+class errorLogger & eLog() {
   return errorLogger::getInstance();
 }
Index: src/log.hpp
===================================================================
--- src/log.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/log.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,4 +15,6 @@
 class errorLogger * eLog();
 void setVerbosity(int verbosityLevel);
+bool DoLog(int verbose);
+bool DoeLog(int verbose);
 
 #endif /* LOG_HPP_ */
Index: src/logger.cpp
===================================================================
--- src/logger.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/logger.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,8 +9,8 @@
 #include "logger.hpp"
 #include "verbose.hpp"
+#include "Patterns/Singleton_impl.hpp"
 
 ofstream nullStream("/dev/null");
 
-logger* logger::instance = NULL;
 int logger::verbosity = 2;
 ostream* logger::nix = &nullStream;
@@ -23,5 +23,4 @@
 logger::logger()
 {
-  instance = NULL;
   verbosity = 2;
 };
@@ -34,28 +33,5 @@
 }
 
-/**
- * Returns the singleton logger instance.
- *
- * \return logger instance
- */
-logger* logger::getInstance() {
-  if (instance == NULL) {
-    instance = new logger();
-  }
-
-  return instance;
-}
-
-
-/**
- * Purges the current logger instance.
- */
-void logger::purgeInstance() {
-  if (instance != NULL) {
-    delete instance;
-  }
-
-  instance = NULL;
-}
+CONSTRUCT_SINGLETON(logger)
 
 /**
Index: src/logger.hpp
===================================================================
--- src/logger.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/logger.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -11,15 +11,16 @@
 #include <iostream>
 
+#include "Patterns/Singleton.hpp"
+
 using namespace std;
 
 class Verbose;
 
-class logger {
+class logger : public Singleton<logger> {
+  friend class Singleton<logger>;
 public :
   static ostream *nix;
   static int verbosity;
 
-  static logger* getInstance();
-  static void purgeInstance();
   static bool DoOutput();
   static void setVerbosity(int verbosityLevel);
@@ -30,7 +31,4 @@
   /** Do not call this destructor directly, use purgeInstance() instead. */
   ~logger();
-
-private:
-  static logger* instance;
 };
 
Index: src/memoryusageobserver.cpp
===================================================================
--- src/memoryusageobserver.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/memoryusageobserver.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -93,6 +93,6 @@
       << pointer << " is not registered by MemoryUsageObserver: ";
     if (msg != NULL)
-      Log() << Verbose(0) << *msg;
-    Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << *msg);
+    DoLog(0) && (Log() << Verbose(0) << endl);
     return;
   }
